#INCLUDE "dbc.h"

***************************************************
* Ukzka pmho pstupu na DBC vlastnosti
***************************************************

* SET PROCEDURE TO DFO.PRG
*LOCAL lcAlias,liID,luValue
*lcAlias=SYS(2015)

** oteven DBC konteineru jako tabulky
*lcDBC="c:\temp\xxd001.dbc"
*lcAlias=SYS(2015)
*USE (lcDBC) IN 0 ALIAS (lcAlias)

** Vrt ID objektu
** pro poloku tabulky i pohledu
*liID=DBC_GetIDObject(lcAlias,_DBC_Field,"xxt001.pol1")

*** a pro tabulku
**liID=DBC_GetIDObject(lcAlias,_DBC_Table,"xxt001")

** Vrt hodnotu vlastnosti
*=DBC_GetProperty(lcAlias,liID,_DBCID_InputMask,@luValue)
*?luValue

** Nastaven hodnoty vlastnosti
*=DBC_SetProperty(lcAlias,liID,_DBCID_InputMask,"99999999")
*=DBC_SetProperty(lcAlias,liID,_DBCID_Format,"!!!!!!!!!!!")

** Vymazn vlastnosti
*=DBC_ClearProperty(lcAlias,liID,_DBCID_InputMask)

** Naten vech vlastnost objektu
*DIME laProps(1)
*liCount=DBC_EnumProperty(lcAlias,liID,@laProps)
*FOR lii=1 to liCount
*    ?laProps(lii,1),laProps(lii,2)
*NEXT

*set proced to 

******************************************************************************************
* Vrt hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_GetIDObject(lcAlias,lcType,lcObjName)
* lcAlias   - Alias otevenho DBC konteineru
* lcType    - Typ objektu
* lcObjName - Nzev objektu

SELE (lcAlias) && Sko na DBC konteiner
IF INLIST(lcType,_DBC_Field,_DBC_Index)
   LOCAL lcParent,lii,lcObj
   lii=AT(".",lcObjName) && Najdi teku
   lcParent=PADR(UPPER(LEFT(lcObjName,lii-1)),128)
   lcObj=PADR(UPPER(SUBST(lcObjName,lii+1)),128)
   * Najdi parenta
   LOCATE FOR INLIST(ObjectType,_DBC_Table,_DBC_View) AND UPPER(ObjectName)==lcParent  AND ! DELE()
   IF FOUND() && Pokud si ho nael
      lii=ObjectID
      * Nyn hledej dan objekt
      LOCATE FOR ParentID=lii AND ObjectType==lcType AND UPPER(ObjectName)==lcObj AND ! DELE()
   ENDIF
ELSE
   LOCATE FOR ObjectType==lcType AND UPPER(ObjectName)==PADR(UPPER(lcObjName),128) AND ! DELE()
ENDIF
RETURN IIF(FOUND(),ObjectID,_DBC_ObjectNotFound)
ENDPROC

******************************************************************************************
* Vrt seznam vlastnosti a jejich hodnot na objektu
******************************************************************************************
PROCEDURE DBC_EnumProperty(lcAlias,liIDObject,laProp)
* lcAlias    - Alias otevenho DBC konteineru
* liIDObject - ID objektu
* @laProp    - Matice, kam se ulo vlastnosti objektu

EXTERNAL ARRAY laProp

LOCAL liStart,liLen,liLenID,lii
liStart=1 && Nastav prvn pozici

SELE (lcAlias) && Sko na DBC konteiner
LOCATE FOR ObjectID=liIDObject && Najdi objekt
IF !FOUND() && Pokud nenael
   RETURN _DBC_ObjectNotFound && Pak vypadni
ENDIF
lii=0 && Resetuj ta
DO WHILE liStart<=LEN(Property)
   liLen=DFO_C4ToI(SUBS(Property,liStart,4)) && Zjisti kompletn dlku 
   liLenID=IIF(DFO_C2ToI(SUBS(Property,liStart+4,2))>256,2,1) && Toto je dlka ID vlastnosti

   lii=lii+1 && Inkrementuj ta
   DIME laProp(lii,3)
   laProp(lii,1)=IIF(liLenID=1,ASC(SUBS(Property,liStart+4+2,liLenID)),DFO_C2ToI(SUBS(Property,liStart+4+2,liLenID))) && ID vlastnosti
   laProp(lii,2)=DBC_ConvertPropertyToValue(laProp(lii,1), SUBS(Property,liStart+3+2+liLenID+1,liLen-(3+2+liLenID+1)) ) && Prove konverzi vlastnosti na hodnotu
   liStart=liStart+liLen
ENDDO
RETURN lii
ENDPROC

******************************************************************************************
* Vrt hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_GetProperty(lcAlias,liIDObject,liIDProp,luValue)
* lcAlias    - Alias otevenho DBC konteineru
* liIDObject - ID objektu
* liIDProp   - ID vlastnosti
* @luValue   - Promnn, do kter se vrt hodnota

LOCAL liStart,liLen,liLenID
liStart=1 && Nastav prvn pozici

SELE (lcAlias) && Sko na DBC konteiner
LOCATE FOR ObjectID=liIDObject && najdi objekt
IF !FOUND() && Pokud nenael
   RETURN _DBC_ObjectNotFound && Pak vypadni
ENDIF
DO WHILE liStart<=LEN(Property)
   liLen=DFO_C4ToI(SUBS(Property,liStart,4)) && Zjisti kompletn dlku 
   liLenID=IIF(DFO_C2ToI(SUBS(Property,liStart+4,2))>256,2,1) && Toto je dlka ID vlastnosti

   * Je to dan vlastnost ?
   IF IIF(liLenID=1,ASC(SUBS(Property,liStart+4+2,liLenID)),DFO_C2ToI(SUBS(Property,liStart+4+2,liLenID)))=liIDProp
      * Prove konverzi vlastnosti na hodnotu
      luValue=DBC_ConvertPropertyToValue(liIDProp, SUBS(Property,liStart+3+2+liLenID+1,liLen-(3+2+liLenID+1)) )
      RETURN _DBC_ObjectFound
   ENDIF
   liStart=liStart+liLen
ENDDO
luValue=DBC_GetDefaultValue(liIDProp)
RETURN _DBC_ObjectFound
ENDPROC

******************************************************************************************
* Nastav hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_SetProperty(lcAlias,liIDObject,liIDProp,luValue)
* lcAlias    - Alias otevenho DBC konteineru
* liIDObject - ID objektu
* liIDProp   - ID vlastnosti
* luValue   - hodnota

LOCAL liStart,liLen,liLenID
liStart=1 && Nastav prvn pozici

SELE (lcAlias) && Sko na DBC konteiner
LOCATE FOR ObjectID=liIDObject && Najdi objekt
IF !FOUND() && Pokud nenael
   RETURN _DBC_ObjectNotFound && Pak vypadni
ENDIF

luValue=DBC_ConvertValueToProperty(liIDProp,luValue) && Prove konverzi hodnoty na vlastnost
DO WHILE liStart<=LEN(Property)
   liLen=DFO_C4ToI(SUBS(Property,liStart,4)) && Zjisti kompletn dlku
   liLenID=IIF(DFO_C2ToI(SUBS(Property,liStart+4,2))>256,2,1) && Toto je dlka ID vlastnosti

   * Je to dan vlastnost ?
   IF IIF(liLenID=1,ASC(SUBS(Property,liStart+4+2,liLenID)),DFO_C2ToI(SUBS(Property,liStart+4+2,liLenID)))=liIDProp
      REPL Property WITH STUFF(Property,liStart,liLen,DFO_IToC4(4+2+liLenID+LEN(luValue))+DFO_IToC2(IIF(liIDProp>256,2,1))+IIF(liIDProp>256,DFO_IToC2(liIDProp),CHR(liIDProp))+luValue)
      RETURN _DBC_ObjectFound
   ENDIF
   liStart=liStart+liLen
ENDDO
REPL Property WITH Property+IToC4(4+2+IIF(liIDProp>256,2,1)+LEN(luValue))+DFO_IToC2(IIF(liIDProp>256,2,1))+IIF(liIDProp>256,DFO_IToC2(liIDProp),CHR(liIDProp))+luValue
RETURN _DBC_ObjectFound
ENDPROC


******************************************************************************************
* Vymae vlastnost z memo pole
******************************************************************************************
PROCEDURE DBC_ClearProperty(lcAlias,liIDObject,liIDProp)
* lcAlias    - Alias otevenho DBC konteineru
* liIDObject - ID objektu
* liIDProp   - ID vlastnosti

LOCAL liStart,liLen,liLenID
liStart=1 && Nastav prvn pozici

SELE (lcAlias) && Sko na DBC konteiner
LOCATE FOR ObjectID=liIDObject && Najdi objekt
IF !FOUND() && Pokud nenael
   RETURN _DBC_ObjectNotFound && Pak vypadni
ENDIF

DO WHILE liStart<=LEN(Property)
   liLen=DFO_C4ToI(SUBS(Property,liStart,4)) && Zjisti kompletn dlku
   liLenID=IIF(DFO_C2ToI(SUBS(Property,liStart+4,2))>256,2,1) && Toto je dlka ID vlastnosti

   * Je to dan vlastnost ?
   IF IIF(liLenID=1,ASC(SUBS(Property,liStart+4+2,liLenID)),DFO_C2ToI(SUBS(Property,liStart+4+2,liLenID)))=liIDProp
      REPL Property WITH STUFF(Property,liStart,liLen,"")
      EXIT
   ENDIF
   liStart=liStart+liLen
ENDDO

RETURN _DBC_ObjectFound
ENDPROC

******************************************************************************************
* provede konverzi hodnoty vlastnosti na hodnotu
******************************************************************************************
PROCEDURE DBC_ConvertPropertyToValue(liIDProp,lcValue)
* liIDProp - ID vlastnosti
* lcValue  - Hodnota vlastnosti

RETURN IIF(INLIST(liIDProp,_DBCID_Comment,_DBCID_Path,;
           _DBCID_RuleExpression,_DBCID_RuleText,_DBCID_InsertTrigger,;
           _DBCID_UpdateTrigger,_DBCID_DeleteTrigger,_DBCID_PrimaryKey,;
           _DBCID_DefaultValue,_DBCID_Caption,_DBCID_ChildTag,;
           _DBCID_ParentTable,_DBCID_Database),LEFT(lcValue,LEN(lcValue)-1),;
       IIF(INLIST(liIDProp,_DBCID_ParentTag,_DBCID_DataSource,;
 	       _DBCID_ConnectString,_DBCID_Password,_DBCID_UserID,;
   	       _DBCID_ParameterList,_DBCID_ConnectName,_DBCID_SQL,;
           _DBCID_Tables,_DBCID_UpdateName,_DBCID_DataType,;
           _DBCID_DisplayClass,_DBCID_DisplayClassLibrary,;
           _DBCID_Format,_DBCID_InputMask,_DBCID_DBCEventFileName),LEFT(lcValue,LEN(lcValue)-1),;
       IIF(INLIST(liIDProp,_DBCID_SubType,_DBCID_DispLogin,;
           _DBCID_Transactions,_DBCID_BatchUpdateCount,_DBCID_SourceType,;
           _DBCID_UpdateType,_DBCID_WhereType),ASC(lcValue),;
       IIF(INLIST(liIDProp,_DBCID_FetchSize,_DBCID_MaxRecords),IIF(lcValue=CHR(255)+CHR(255)+CHR(255)+CHR(255),-1,DFO_C4ToIRev(lcValue)),;
       IIF(INLIST(liIDProp,_DBCID_ConnectTimeout,_DBCID_IdleTimeout,_DBCID_QueryTimeout,;
           _DBCID_WaitTime,_DBCID_PacketSize,_DBCID_UseMemoSize,_DBCID_Version),DFO_C4ToIRev(lcValue),;
       IIF(INLIST(liIDProp,_DBCID_Prim_Cand,_DBCID_Asynchronous,_DBCID_BatchMode,;
           _DBCID_DispWarnings,_DBCID_FetchMemo,_DBCID_ShareConnection,;
           _DBCID_SendUpdates,_DBCID_KeyField,_DBCID_Updatable,;
           _DBCID_CompareMemo,_DBCID_FetchAsNeeded,_DBCID_Offline,;
           _DBCID_Prepared,_DBCID_DBCEvents,_DBCID_AllowSimultaneousFetch,_DBCID_DisconnectRollback),ASC(lcValue)=1,lcValue))))))
ENDPROC

******************************************************************************************
* provede konverzi hodnoty na hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_ConvertValueToProperty(liIDProp,luValue)
* liIDProp - ID vlastnosti
* luValue  - Hodnota

RETURN IIF(INLIST(liIDProp,_DBCID_Comment,_DBCID_Path,;
           _DBCID_RuleExpression,_DBCID_RuleText,_DBCID_InsertTrigger,;
           _DBCID_UpdateTrigger,_DBCID_DeleteTrigger,_DBCID_PrimaryKey,;
           _DBCID_DefaultValue,_DBCID_Caption,_DBCID_ChildTag,;
           _DBCID_ParentTable,_DBCID_Database),luValue+CHR(0),;
       IIF(INLIST(liIDProp,_DBCID_ParentTag,_DBCID_DataSource,;
 	       _DBCID_ConnectString,_DBCID_Password,_DBCID_UserID,;
   	       _DBCID_ParameterList,_DBCID_ConnectName,_DBCID_SQL,;
           _DBCID_Tables,_DBCID_UpdateName,_DBCID_DataType,;
           _DBCID_DisplayClass,_DBCID_DisplayClassLibrary,;
           _DBCID_Format,_DBCID_InputMask,_DBCID_DBCEventFileName),luValue+CHR(0),;
       IIF(INLIST(liIDProp,_DBCID_SubType,_DBCID_DispLogin,;
           _DBCID_Transactions,_DBCID_BatchUpdateCount,_DBCID_SourceType,;
           _DBCID_UpdateType,_DBCID_WhereType),CHR(luValue),;
       IIF(INLIST(liIDProp,_DBCID_FetchSize,_DBCID_MaxRecords),IIF(luValue=-1,CHR(255)+CHR(255)+CHR(255)+CHR(255),DFO_IToC4Rev(luValue)),;
       IIF(INLIST(liIDProp,_DBCID_ConnectTimeout,_DBCID_IdleTimeout,_DBCID_QueryTimeout,;
           _DBCID_WaitTime,_DBCID_PacketSize,_DBCID_UseMemoSize,_DBCID_Version),DFO_IToC4Rev(luValue),;
       IIF(INLIST(liIDProp,_DBCID_Prim_Cand,_DBCID_Asynchronous,_DBCID_BatchMode,;
           _DBCID_DispWarnings,_DBCID_FetchMemo,_DBCID_ShareConnection,_DBCID_DisconnectRollback,;
           _DBCID_SendUpdates,_DBCID_KeyField,_DBCID_Updatable,;
           _DBCID_CompareMemo,_DBCID_FetchAsNeeded,_DBCID_Offline,;
           _DBCID_Prepared,_DBCID_DBCEvents,_DBCID_AllowSimultaneousFetch),IIF(luValue,CHR(1),CHR(0)),luValue))))))
ENDPROC

******************************************************************************************
* Vrt defaultn hodnotu 
******************************************************************************************
PROCEDURE DBC_GetDefaultValue(liIDProp)
* liIDProp - ID vlastnosti

RETURN IIF(INLIST(liIDProp,_DBCID_Comment,_DBCID_Path,;
           _DBCID_RuleExpression,_DBCID_RuleText,_DBCID_InsertTrigger,;
           _DBCID_UpdateTrigger,_DBCID_DeleteTrigger,_DBCID_PrimaryKey,;
           _DBCID_DefaultValue,_DBCID_Caption,_DBCID_ChildTag,;
           _DBCID_ParentTable,_DBCID_Database),"",;
       IIF(INLIST(liIDProp,_DBCID_ParentTag,_DBCID_DataSource,;
 	       _DBCID_ConnectString,_DBCID_Password,_DBCID_UserID,;
   	       _DBCID_ParameterList,_DBCID_ConnectName,_DBCID_SQL,;
           _DBCID_Tables,_DBCID_UpdateName,_DBCID_DataType,;
           _DBCID_DisplayClass,_DBCID_DisplayClassLibrary,;
           _DBCID_Format,_DBCID_InputMask,_DBCID_DBCEventFileName),"",;
       IIF(INLIST(liIDProp,_DBCID_SubType,_DBCID_ConnectTimeout,_DBCID_IdleTimeout,_DBCID_QueryTimeout),0,;
       IIF(INLIST(liIDProp,_DBCID_DispLogin,_DBCID_Transactions,_DBCID_BatchUpdateCount,;
           _DBCID_SourceType,_DBCID_UpdateType,_DBCID_WhereType),1,;
       IIF(liIDProp=_DBCID_MaxRecords,-1,;
       IIF(liIDProp=_DBCID_Version,10,;
       IIF(INLIST(liIDProp,_DBCID_WaitTime,_DBCID_FetchSize),100,;
       IIF(liIDProp=_DBCID_PacketSize,4096,;
       IIF(liIDProp=_DBCID_UseMemoSize,255,;
       IIF(INLIST(liIDProp,_DBCID_DispWarnings,_DBCID_ShareConnection,_DBCID_CompareMemo),.T.,;
       IIF(INLIST(liIDProp,_DBCID_Prim_Cand,_DBCID_Asynchronous,_DBCID_BatchMode,;
           _DBCID_FetchMemo,_DBCID_AllowSimultaneousFetch,_DBCID_DisconnectRollback,;
           _DBCID_SendUpdates,_DBCID_KeyField,_DBCID_Updatable,;
           _DBCID_FetchAsNeeded,_DBCID_Offline,;
           _DBCID_Prepared,_DBCID_DBCEvents),.F.,.NULL.)))))))))))

ENDPROC

******************************************************************************************
* Vrt relativn cestu k DBC konteineru
******************************************************************************************
PROCEDURE GetDBCContainer(luFile,lcDBC)
* luFile - Handle, nebo cesta a nzev DBF souboru
* @lcDBC - Sem se vrt nzev DBC konteineru

IF EMPTY(luFile)
   RETURN _DBC_ErrParamFailed
ENDIF

LOCAL llHandle,lihFile,liFirst,lii
IF TYPE("luFile")="N" && Pokud je to slo
   llHandle=.T. && Pak jde o handl
   lihFile=luFile
ELSE
   IF TYPE("luFile")="C"  && Jde o etzec (nzev souboru)
      lihFile=FOPEN(ALLT(luFile),10) && Otevi soubor
      IF lihFile=-1 && Pokud se to nepodailo otevt
         RETURN _DBC_ErrNotOpenLowLevelFile && Pak se vra
      ENDIF
   ELSE
      RETURN _DBC_ErrParamFailed
   ENDIF
ENDIF

=FSEEK(lihFile,0) && Sko na 0 byte
IF ASC(FREAD(lihFile,1))=0x30 && Pokud je 0 bytu=0x30
   =FSEEK(lihFile,8) && Sko na 8 byte
   liFirst=ASC(FREAD(lihFile,1)) && Nati ni byte
   liFirst=(liFirst+ASC(FREAD(lihFile,1))*256)-263
   =FSEEK(lihFile,liFirst) && Sko na potek informac o DBC konteineru
   lcDBC=FREAD(lihFile,263) && Nati DBC konteiner
   lii=AT(CHR(0),lcDBC) && Najdi prvn znak AT
   IF lii>0 && Pokud tam nco je
      lcDBC=LEFT(lcDBC,lii-1) && Pak to oe
   ENDIF
ENDIF

IF !llHandle && Pokud nelo o handle souboru
   =FCLOSE(lihFile) && Uzavi soubor
ENDIF
RETURN _DBC_ErrOK && Vra pznak, e se to podailo
ENDPROC


******************************************************************************************
* Vrt typ tabulky
******************************************************************************************
PROCEDURE GetTypeDBF(luFile,liType)
* luFile  - Handle, nebo cesta a nzev DBF souboru
* @liType - Sem se vrt typ tabulky

IF EMPTY(luFile)
   RETURN _DBC_ErrParamFailed
ENDIF

LOCAL llHandle,lihFile,liType
liType=0
IF TYPE("luFile")="N" && Pokud je to slo
   llHandle=.T. && Pak jde o handl
   lihFile=luFile
ELSE
   IF TYPE("luFile")="C"  && Jde o etzec (nzev souboru)
      lihFile=FOPEN(ALLT(luFile),10) && Otevi soubor
      IF lihFile=-1 && Pokud se to nepodailo otevt
         RETURN _DBC_ErrNotOpenLowLevelFile && Pak se vra
      ENDIF
   ELSE
      RETURN _DBC_ErrParamFailed
   ENDIF
ENDIF

=FSEEK(lihFile,0) && Sko na 0 byte
liType=ASC(FREAD(lihFile,1))

IF !llHandle && Pokud nelo o handle souboru
   =FCLOSE(lihFile) && Uzavi soubor
ENDIF
RETURN liType && Vra typ tabulky
ENDPROC

******************************************************************************************
* Vrt pocet vt tabulky pmo ze souboru
******************************************************************************************
PROCEDURE GetReccountDBF(luFile)
* luFile - Handle, nebo cesta a nzev DBF souboru

IF EMPTY(luFile)
   RETURN _DBC_ErrParamFailed
ENDIF

LOCAL llHandle,lihFile,liRecc
IF TYPE("luFile")="N" && Pokud je to slo
   llHandle=.T. && Pak jde o handl
   lihFile=luFile
ELSE
   IF TYPE("luFile")="C"  && Jde o etzec (nzev souboru)
      lihFile=FOPEN(ALLT(luFile),10) && Otevi soubor
      IF lihFile=-1 && Pokud se to nepodailo otevt
         RETURN _DBC_ErrNotOpenLowLevelFile && Pak se vra
      ENDIF
   ELSE
      RETURN _DBC_ErrParamFailed
   ENDIF
ENDIF

=FSEEK(lihFile,4) && Sko na 4 byte
liRecc=C4ToI(FREAD(lihFile,4))

IF !llHandle && Pokud nelo o handle souboru
   =FCLOSE(lihFile) && Uzavi soubor
ENDIF
RETURN liRecc && Vra poet vt
ENDPROC



* Konverzn funkce
********************************
PROCEDURE DFO_C4ToI(lcInt)  && slo v etzcovm tvaru WINAPI 32 bit
RETURN ASC(LEFT(lcInt,1))+;
       ASC(SUBS(lcInt,2,1))*256+;
       ASC(SUBS(lcInt,3,1))*65536+;
       ASC(RIGHT(lcInt,1))*16777216  && Vra slo v decimlnm tvaru
ENDPROC

********************************
PROCEDURE DFO_C4ToIRev(lcInt)  && slo v etzcovm tvaru WINAPI 32 bit - reverz
RETURN ASC(LEFT(lcInt,1))*16777216+;
       ASC(SUBS(lcInt,2,1))*65536+;
       ASC(SUBS(lcInt,3,1))*256+;
       ASC(RIGHT(lcInt,1))  && Vra slo v decimlnm tvaru
ENDPROC

                  
                  

******************************************************************************************
PROCEDURE DFO_C2ToI(lcInt)  && slo v etzcovm tvaru WINAPI 16 bit
RETURN ASC(LEFT(lcInt,1))+ASC(RIGHT(lcInt,1))*256  && Vra slo v decimlnm tvaru
ENDPROC

********************************
PROCEDURE DFO_IToC2(liVal) && Pevede slo na 2 bajtov etzec
LOCAL lcVal,lii

lii=INT(liVal/256) && Vydl 256
lcVal=CHR(liVal-lii*256) && Peve rozdl na znak a piti ho
liVal=lii && Zapi novou hodnotu pro pevod

lii=INT(liVal/256) && Vydl 256
RETURN lcVal+CHR(liVal-lii*256)
ENDPROC


********************************
PROCEDURE DFO_IToC4(liVal) && Pevede slo na 4 bajtov etzec
LOCAL lcVal,lii

lii=INT(liVal/256) && Vydl 256
lcVal=CHR(liVal-lii*256) && Peve rozdl na znak a piti ho
liVal=lii && Zapi novou hodnotu pro pevod

lii=INT(liVal/256) && Vydl 256
lcVal=lcVal+CHR(liVal-lii*256)
liVal=lii && Zapi novou hodnotu pro pevod

lii=INT(liVal/256) && Vydl 256
lcVal=lcVal+CHR(liVal-lii*256)
liVal=lii && Zapi novou hodnotu pro pevod

lii=INT(liVal/256) && Vydl 256
RETURN lcVal+CHR(liVal-lii*256) && Peve rozdl na znak a piti ho
ENDPROC

********************************
PROCEDURE DFO_IToC4Rev(liVal) && Pevede slo na 4 bajtov etzec  - reverz
LOCAL lcVal,lii

lii=INT(liVal/256) && Vydl 256
lcVal=CHR(liVal-lii*256) && Peve rozdl na znak a piti ho
liVal=lii && Zapi novou hodnotu pro pevod

lii=INT(liVal/256) && Vydl 256
lcVal=CHR(liVal-lii*256)+lcVal
liVal=lii && Zapi novou hodnotu pro pevod

lii=INT(liVal/256) && Vydl 256
lcVal=CHR(liVal-lii*256)+lcVal
liVal=lii && Zapi novou hodnotu pro pevod

lii=INT(liVal/256) && Vydl 256
RETURN CHR(liVal-lii*256)+lcVal && Peve rozdl na znak a piti ho
ENDPROC

